<?php
namespace PME\Controllers\Custo;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class CustoRealPeriodoController extends \Zeedhi\Framework\Controller\Report {

    protected $birtStrategy;
    protected $crudService;
    protected $lista;
    protected $utilities;
    protected $CustoPlanejadoCardapioController;

    public function __construct(ReportService $reportService, $birtStrategy, $crudService, $lista, $utilities, $CustoPlanejadoCardapioController) {
      $this->birtStrategy  = $birtStrategy;
      $this->crudService   = $crudService;
      $this->lista         = $lista;
      $this->utilities     = $utilities;
      $this->CustoPlanejadoCardapioController = $CustoPlanejadoCardapioController;

      parent::__construct($reportService);
    }

    protected $reportMapping = array (
      'PME08100' => 
        array (
          'strategy' => 'BIRT',
          'parameterMapping' => 
          array (
            "NMFILCENTPME"  => "P_NMFILCENTPME",
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "LISTAFILI"     => "P_LISTAFILI",
            "DTDE"          => "P_DATAINIC",
            "DTATE"         => "P_DATAFINA",
            "NMTIPOCUSTO"   => "P_NMCUSTO",
            "DTPERINI"      => "P_DTPERIINIC",
            "DTPERFIN"      => "P_DTPERIFINA",
            "ESTOCAVEIS"    => "P_IDESTOCAVEIS",
            "NAOESTOCAVEIS" => "P_IDNAOESTOC",
            "CDTIPOCUSTO"   => "P_NRTIPOCUSTO",
            "TAMACNIVEL"    => "P_NRTAMACNIVEL",
            "TAMCODIGO"     => "P_NRTAMCODIGO",
            "PRODUCTMASK"   => "P_PRODUCTMASK",
            "AGRUPMASK"     => "P_AGRUPMASK",
            "NRORG"         => "P_NRORG"
          )
        ),
      'PME08101' => 
        array (
          'strategy' => 'BIRT',
          'parameterMapping' => 
          array (
            "NMFILCENTPME"  => "P_NMFILCENTPME",
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "LISTAFILI"     => "P_LISTAFILI",
            "DTDE"          => "P_DATAINIC",
            "DTATE"         => "P_DATAFINA",
            "NMTIPOCUSTO"   => "P_NMCUSTO",
            "DTPERINI"      => "P_DTPERIINIC",
            "DTPERFIN"      => "P_DTPERIFINA",
            "ESTOCAVEIS"    => "P_IDESTOCAVEIS",
            "NAOESTOCAVEIS" => "P_IDNAOESTOC",
            "CDTIPOCUSTO"   => "P_NRTIPOCUSTO",
            "TAMACNIVEL"    => "P_NRTAMACNIVEL",
            "TAMCODIGO"     => "P_NRTAMCODIGO",
            "PRODUCTMASK"   => "P_PRODUCTMASK",
            "AGRUPMASK"     => "P_AGRUPMASK",
            "NRORG"         => "P_NRORG"
          )
          ),
      'PME08102' => 
        array (
          'strategy' => 'BIRT',
          'parameterMapping' => 
          array (
            "NMFILCENTPME"  => "P_NMFILCENTPME",
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "LISTAFILI"     => "P_LISTAFILI",
            "DTDE"          => "P_DATAINIC",
            "DTATE"         => "P_DATAFINA",
            "NMTIPOCUSTO"   => "P_NMCUSTO",
            "DTPERINI"      => "P_DTPERIINIC",
            "DTPERFIN"      => "P_DTPERIFINA",
            "ESTOCAVEIS"    => "P_IDESTOCAVEIS",
            "NAOESTOCAVEIS" => "P_IDNAOESTOC",
            "CDTIPOCUSTO"   => "P_NRTIPOCUSTO",
            "TAMACNIVEL"    => "P_NRTAMACNIVEL",
            "TAMCODIGO"     => "P_NRTAMCODIGO",
            "PRODUCTMASK"   => "P_PRODUCTMASK",
            "AGRUPMASK"     => "P_AGRUPMASK",
            "NRORG"         => "P_NRORG"
          )
        )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      
      $row['DTPERINI'] = $row['DTDE'];
      $row['DTPERFIN'] = $row['DTATE'];
      $row['NRORG'] = $this->utilities->getNrOrg();

      if(empty($row['UNIDADE'])) $row['CDFILIAL'] = $this->CustoPlanejadoCardapioController->getUnidades($row);
      else $row['CDFILIAL'] = join("_", $row['UNIDADE']);
      
      $row['LISTAFILI'] = $this->lista->geraLista($row['CDFILIAL'], $row['NRORG']);
      
      if($row['ORDENA'] == 0) $row['TAMCODIGO'] = 10;
      else $row['TAMCODIGO'] = 0;
      
      if($row['CD_REPORT_CODE'] == 'PME08102') $row['TAMACNIVEL'] = 0;

      $this->birtStrategy->setReportLocale($this->utilities->getLanguage());
      $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }
}