<?php
namespace Folha\Entities;

use Geral\Entities\Base\Projeto;
use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;

class MigEscalatrabh extends Base\MigEscalatrabh
{

    const DEFAULT_DESCANSO_SEMANAL = 'DOMINGO';
    const DEFAULT_QTHRESCALA = '7,3333333';
    const DEFAULT_QTHRSEMEST = '44';

    /**
     * @param $nrescalatrabh
     * @return \Folha\Entities\MigEscalatrabh
     */
    public function setNrescalatrabh ($nrescalatrabh) {

        $nrescalatrabh = \Importacao\Logic\Validacoes::verificaChaveDuplicada('MIG_ESCALATRABH', 'NRESCALATRABH', ProjetoImportacao::getNrorg(), $nrescalatrabh);
        $this->nrescalatrabh = $nrescalatrabh;
    }

//    /**
//     * @param $nrescalatrabm
//     * @return \Folha\Entities\MigEscalatrabh
//     */
//    public function setNrescalatrabm ($nrescalatrabm) {
//        $nrescalatrabm = \Importacao\Logic\Validacoes::verificaChaveMae('GPE_ESCALATRABM', 'NRESCALATRABM', \FPA::getNrorgTrabalho(), $nrescalatrabm);
//        $this->nrescalatrabm = $nrescalatrabm;
//    }

    /**
     * @param $nmescalatrabh
     * @return \Folha\Entities\MigEscalatrabh
     */
    public function setNmescalatrabh ($nmescalatrabh) {
        if (empty($nmescalatrabh)) {
            throw new \Exception("Campo Obrigatório: 'Nome'");
        }

        $this->nmescalatrabh = $nmescalatrabh;
    }

    /**
     * @param $descansosemanal
     * @return \Folha\Entities\MigEscalatrabh
     */
    public function setDescansosemanal ($descansosemanal) {
        if (empty($descansosemanal)) {
            $descansosemanal = self::DEFAULT_DESCANSO_SEMANAL;
        }

        $this->descansosemanal = $descansosemanal;
    }

    /**
     * @param $qthrescalatrabh
     * @return \Folha\Entities\MigEscalatrabh
     */
    public function setQthrescalatrabh ($qthrescalatrabh) {
        if (empty($qthrescalatrabh)) {
            $qthrescalatrabh = self::DEFAULT_QTHRESCALA;
        }

        $qthrescalatrabh = str_replace(',', '.', $qthrescalatrabh);

        $this->qthrescalatrabh = $qthrescalatrabh;
    }

    /**
     * @param $qthrsemesctrabh
     * @return \Folha\Entities\MigEscalatrabh
     */
    public function setQthrsemesctrabh ($qthrsemesctrabh) {
        if (empty($qthrsemesctrabh)) {
            $qthrsemesctrabh = self::DEFAULT_QTHRSEMEST;
        }

        $this->qthrsemesctrabh = $qthrsemesctrabh;
    }

    /**
     * @return \Folha\Entities\MigEscalatrabh
     */
    public function setDtmescompetenc ($dtmescompetenc)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtmescompetenc)) {
            throw new \Exception("Campo Obrigatório: Data '$dtmescompetenc' com formato inválido ou em branco.");
        }

        if (!($dtmescompetenc instanceof \DateTime)) {
            $dtmescompetenc = DateUtil::getDataDeString($dtmescompetenc);
        }

        $this->dtmescompetenc = $dtmescompetenc;
    }

    /**
     * @param mixed $dtinclusao
     * @return \Folha\Entities\MigEscalatrabm|void
     */
    public function setDtinclusao($dtinclusao)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data '$dtinclusao' com formato inválido ou em branco.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

    /**
     * @param mixed $dtultatu
     * @return \Folha\Entities\MigEscalatrabm|void
     */
    public function setDtultatu($dtultatu)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data '$dtultatu' com formato inválido ou branco.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

}