/*
 Tecnisa - Tecnologia em Informtica

 Nome: Importa_Fluxo_Ajuste

 Descrio:
  Atualiza os ajustes dos boletos a Receber e Pagar,
  nas respectivas tabelas MOVFXAJBOLR e MOVFXAJBOLP.

-- @C:\WIN_PRJ\SQL\SQLSERVER\0000_FINTMP_IMPORTA_FLUXO_AJUSTE.SQL;
-- EXECUTE IMPORTA_FLUXO_AJUSTE
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

 */

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'IMPORTA_FLUXO_AJUSTE' AND
	           TYPE = 'P' 			              AND
              U.UID = O.UID                    AND
              U.NAME = USER)

DROP PROCEDURE IMPORTA_FLUXO_AJUSTE
GO

CREATE PROCEDURE IMPORTA_FLUXO_AJUSTE
AS
   DECLARE @V_ACHOUP              NUMERIC;
   DECLARE @V_ACHOUR              NUMERIC;
   DECLARE @V_CTFLUXO             NUMERIC;
   DECLARE @V_VRAJBOLPAG          NUMERIC(16,2);
   DECLARE @V_VRAJBOLREC          NUMERIC(16,2);
   DECLARE @V_CDCLASSFINA         VARCHAR(06);
   DECLARE @V_VRAJANTE            NUMERIC(16,2);
   DECLARE @V_VRAJNOVO            NUMERIC(16,2);

   DECLARE @V_AJBOLP_CDFILIAL     VARCHAR(04);
   DECLARE @V_AJBOLP_NRLANBOLPAG  VARCHAR(10);
   DECLARE @V_AJBOLP_CDAJUCTPAG   VARCHAR(04);
   DECLARE @V_AJBOLP_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_AJBOLP_CDEMMFAJBOLP VARCHAR(02);
   DECLARE @V_AJBOLP_CDFIMFAJBOLP VARCHAR(04);
   DECLARE @V_AJBOLP_DTMOVFLUXO   DATETIME;
   DECLARE @V_AJBOLP_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_AJBOLP_VRAJBOLPAG   NUMERIC(16,2);
   DECLARE @V_AJBOLP_IDAJUCTPAG   VARCHAR(01);

   DECLARE @V_RATP_CDFILIAL       VARCHAR(04);
   DECLARE @V_RATP_NRLANBOLPAG    VARCHAR(10);
   DECLARE @V_RATP_CDAJUCTPAG     VARCHAR(04);
   DECLARE @V_RATP_VRAJBOLPAG     NUMERIC(16,2);
   DECLARE @V_RATP_CDCLASSFINA    VARCHAR(06);
   DECLARE @V_RATP_CDEMPRESA      VARCHAR(02);
   DECLARE @V_RATP_CDFIMOVFLPAG   VARCHAR(04);
   DECLARE @V_RATP_DTMOVFLUXO     DATETIME;
   DECLARE @V_RATP_IDMOVFLUXO     VARCHAR(01);
   DECLARE @V_RATP_IDAJUCTPAG     VARCHAR(01);
   DECLARE @V_RATP_IDSTATPAG      VARCHAR(01);
   DECLARE @V_RATP_VRRATAJBOLPAG  NUMERIC(16,2);

   DECLARE @V_AJBOLR_CDFILIAL     VARCHAR(04);
   DECLARE @V_AJBOLR_NRLANBOLREC  VARCHAR(10);
   DECLARE @V_AJBOLR_CDAJUCTREC   VARCHAR(04);
   DECLARE @V_AJBOLR_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_AJBOLR_CDEMMFAJBOLR VARCHAR(02);
   DECLARE @V_AJBOLR_CDFIMFAJBOLR VARCHAR(04);
   DECLARE @V_AJBOLR_DTMOVFLUXO   DATETIME;
   DECLARE @V_AJBOLR_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_AJBOLR_VRAJBOLREC   NUMERIC(16,2);
   DECLARE @V_AJBOLR_IDAJUCTREC   VARCHAR(01);

   DECLARE @V_RATR_CDFILIAL      VARCHAR(04);
   DECLARE @V_RATR_NRLANBOLREC   VARCHAR(10);
   DECLARE @V_RATR_CDAJUCTREC    VARCHAR(04);
   DECLARE @V_RATR_VRAJBOLREC    NUMERIC(16,2);
   DECLARE @V_RATR_CDCLASSFINA   VARCHAR(06);
   DECLARE @V_RATR_CDEMPRESA     VARCHAR(02);
   DECLARE @V_RATR_CDFIMOVFLREC  VARCHAR(04);
   DECLARE @V_RATR_DTMOVFLUXO    DATETIME;
   DECLARE @V_RATR_IDMOVFLUXO    VARCHAR(01);
   DECLARE @V_RATR_IDAJUCTREC    VARCHAR(01);
   DECLARE @V_RATR_IDSTATREC     VARCHAR(01);
   DECLARE @V_RATR_VRRATAJBOLREC NUMERIC(16,2);

   DECLARE @V_AJCTP_CDFILIAL      VARCHAR(04);
   DECLARE @V_AJCTP_NRLANCTONF    VARCHAR(10);
   DECLARE @V_AJCTP_NRSEQVENPAG   VARCHAR(02);
   DECLARE @V_AJCTP_NRPARCELAPAG  VARCHAR(02);
   DECLARE @V_AJCTP_DTAJUSTEPAG   DATETIME;
   DECLARE @V_AJCTP_CDAJUCTPAG    VARCHAR(04);
   DECLARE @V_AJCTP_DSAJUSTEPAG   VARCHAR(20);
   DECLARE @V_AJCTP_VRAJUSTEPAG   NUMERIC(16,2);
   DECLARE @V_AJCTP_CDECTBAJPAG   VARCHAR(02);
   DECLARE @V_AJCTP_NRLCTBAJPAG   VARCHAR(10);
   DECLARE @V_AJCTP_CDCLASSFINA   VARCHAR(06);
   DECLARE @V_AJCTP_CDEMMFAJCNTP  VARCHAR(02);
   DECLARE @V_AJCTP_CDFIMFAJCNTP  VARCHAR(04);
   DECLARE @V_AJCTP_DTMOVFLUXO    DATETIME;
   DECLARE @V_AJCTP_IDMOVFLUXO    VARCHAR(01);
   DECLARE @V_AJCTP_IDAJUCTPAG    VARCHAR(01);

   DECLARE @V_AJCTR_CDFILIAL      VARCHAR(04);
   DECLARE @V_AJCTR_NRLANCTONF    VARCHAR(10);
   DECLARE @V_AJCTR_DTAJUSTEREC   DATETIME;
   DECLARE @V_AJCTR_CDAJUCTREC    VARCHAR(04);
   DECLARE @V_AJCTR_DSAJUSTEREC   VARCHAR(20);
   DECLARE @V_AJCTR_VRAJUSTEREC   NUMERIC(16,2);
   DECLARE @V_AJCTR_CDECTBAJREC   VARCHAR(02);
   DECLARE @V_AJCTR_NRLCTBAJREC   VARCHAR(10);
   DECLARE @V_AJCTR_NRSEQVENREC   VARCHAR(02);
   DECLARE @V_AJCTR_NRPARCELAREC  VARCHAR(02);
   DECLARE @V_AJCTR_CDCLASSFINA   VARCHAR(06);
   DECLARE @V_AJCTR_CDEMMFAJCNTR  VARCHAR(02);
   DECLARE @V_AJCTR_CDFIMFAJCNTR  VARCHAR(04);
   DECLARE @V_AJCTR_DTMOVFLUXO    DATETIME;
   DECLARE @V_AJCTR_IDMOVFLUXO    VARCHAR(01);
   DECLARE @V_AJCTR_IDAJUCTREC    VARCHAR(01);

BEGIN
   DECLARE C_AJBOLP CURSOR FOR
      SELECT
         AJ.CDFILIAL,    AJ.NRLANBOLPAG,  AJ.CDAJUCTPAG,
         AJ.CDCLASSFINA, AJ.CDEMMFAJBOLP, AJ.CDFIMFAJBOLP,
         AJ.DTMOVFLUXO,  AJ.IDMOVFLUXO,   AJ.VRAJBOLPAG,
         TA.IDAJUCTPAG
      FROM TIPOAJPAGAR TA, AJBOLPAG AJ
      WHERE AJ.CDAJUCTPAG = TA.CDAJUCTPAG
      ORDER BY AJ.CDFILIAL, AJ.NRLANBOLPAG, AJ.CDAJUCTPAG;

   OPEN C_AJBOLP;

   FETCH NEXT FROM C_AJBOLP INTO @V_AJBOLP_CDFILIAL,    @V_AJBOLP_NRLANBOLPAG, @V_AJBOLP_CDAJUCTPAG,
                                 @V_AJBOLP_CDCLASSFINA, @V_AJBOLP_CDEMMFAJBOLP, @V_AJBOLP_CDFIMFAJBOLP,
                                 @V_AJBOLP_DTMOVFLUXO,  @V_AJBOLP_IDMOVFLUXO,   @V_AJBOLP_VRAJBOLPAG,
                                 @V_AJBOLP_IDAJUCTPAG;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT
         @V_ACHOUP = COUNT(*)
      FROM
         MOVFXAJBOLP MA
      WHERE
         (@V_AJBOLP_CDFILIAL    = MA.CDFILIBOLPAG) AND
         (@V_AJBOLP_NRLANBOLPAG = MA.NRLANBOLPAG)  AND
         (@V_AJBOLP_CDAJUCTPAG  = MA.CDAJUCTPAG);

      IF @V_ACHOUP = 0 BEGIN
         IF @V_AJBOLP_CDCLASSFINA IS NOT NULL BEGIN
            IF @V_AJBOLP_IDAJUCTPAG = 'A' BEGIN
               SET @V_VRAJBOLPAG = @V_AJBOLP_VRAJBOLPAG * -1;
            END
            ELSE BEGIN
               SET @V_VRAJBOLPAG = @V_AJBOLP_VRAJBOLPAG;
            END;

            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJBOLP_CDEMMFAJBOLP, @V_AJBOLP_CDFIMFAJBOLP,
                                         @V_AJBOLP_DTMOVFLUXO,   @V_AJBOLP_IDMOVFLUXO,
                                         @V_AJBOLP_CDCLASSFINA,  0,  @V_VRAJBOLPAG;
         END;

         DECLARE C_RATP CURSOR FOR
            SELECT
               AJ.CDFILIAL, AJ.NRLANBOLPAG, AJ.CDAJUCTPAG,
               AJ.VRAJBOLPAG,   CP.CDCLASSFINA, CP.CDEMPRESA,
               CP.CDFIMOVFLPAG, CP.DTMOVFLUXO,  CP.IDMOVFLUXO,
               TA.IDAJUCTPAG,   CP.IDSTATPAG,
               (CASE MAX(BP.VRBOLPAG) WHEN 0
               THEN 0
               ELSE (MAX(AJ.VRAJBOLPAG) * SUM(CP.VRATUAPAG))/ MAX(BP.VRBOLPAG) END) VRRATAJBOLPAG
            FROM
               CONTAPAGAR  CP, BOLETPAGAR BP,
               TIPOAJPAGAR TA, AJBOLPAG   AJ
            WHERE
               (AJ.CDFILIAL     = @V_AJBOLP_CDFILIAL)    AND
               (AJ.NRLANBOLPAG  = @V_AJBOLP_NRLANBOLPAG) AND
               (AJ.CDAJUCTPAG   = @V_AJBOLP_CDAJUCTPAG)  AND
               (TA.CDAJUCTPAG   = AJ.CDAJUCTPAG)  AND
               (BP.CDFILIAL     = AJ.CDFILIAL)    AND
               (BP.NRLANBOLPAG  = AJ.NRLANBOLPAG) AND
               (CP.CDFILIBPAG   = BP.CDFILIAL)    AND
               (CP.NRLANBOLPAG  = BP.NRLANBOLPAG)
            GROUP BY
               AJ.CDFILIAL,     AJ.NRLANBOLPAG, AJ.CDAJUCTPAG,
               AJ.VRAJBOLPAG,   CP.CDCLASSFINA, CP.CDEMPRESA,
               CP.CDFIMOVFLPAG, CP.DTMOVFLUXO,  CP.IDMOVFLUXO,
               TA.IDAJUCTPAG,   CP.IDSTATPAG;

         OPEN C_RATP;

         FETCH NEXT FROM C_RATP INTO @V_RATP_CDFILIAL,     @V_RATP_NRLANBOLPAG, @V_RATP_CDAJUCTPAG,   @V_RATP_VRAJBOLPAG,
                                     @V_RATP_CDCLASSFINA,  @V_RATP_CDEMPRESA,   @V_RATP_CDFIMOVFLPAG, @V_RATP_DTMOVFLUXO,
                                     @V_RATP_IDMOVFLUXO,   @V_RATP_IDAJUCTPAG,  @V_RATP_IDSTATPAG,    @V_RATP_VRRATAJBOLPAG;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF @V_AJBOLP_CDCLASSFINA IS NOT NULL BEGIN
               IF @V_RATP_IDAJUCTPAG = 'A' BEGIN
                  SET @V_VRAJBOLPAG = ROUND(@V_RATP_VRRATAJBOLPAG, 2);
               END
               ELSE BEGIN
                  SET @V_VRAJBOLPAG = ROUND(@V_RATP_VRRATAJBOLPAG * -1, 2);
               END;

               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_RATP_CDEMPRESA,   @V_RATP_CDFIMOVFLPAG,
                                            @V_RATP_DTMOVFLUXO,  @V_RATP_IDMOVFLUXO,
                                            @V_RATP_CDCLASSFINA, 0, @V_VRAJBOLPAG;

               INSERT INTO MOVFXAJBOLP
                  (CDCLASSFINA, CDEMPRESA,  CDFILIAL,
                   DTMOVFLUXO,  IDMOVFLUXO, CDFILIBOLPAG,
                   NRLANBOLPAG, CDAJUCTPAG, VRFXAJBOLPAG)
               VALUES
                  (@V_RATP_CDCLASSFINA, @V_RATP_CDEMPRESA,  @V_RATP_CDFIMOVFLPAG,
                   @V_RATP_DTMOVFLUXO,  @V_RATP_IDMOVFLUXO, @V_RATP_CDFILIAL,
                   @V_RATP_NRLANBOLPAG, @V_RATP_CDAJUCTPAG, @V_RATP_VRRATAJBOLPAG);
                   
            END;
            FETCH NEXT FROM C_RATP INTO @V_RATP_CDFILIAL,     @V_RATP_NRLANBOLPAG, @V_RATP_CDAJUCTPAG,   @V_RATP_VRAJBOLPAG,
                                        @V_RATP_CDCLASSFINA,  @V_RATP_CDEMPRESA,   @V_RATP_CDFIMOVFLPAG, @V_RATP_DTMOVFLUXO,
                                        @V_RATP_IDMOVFLUXO,   @V_RATP_IDAJUCTPAG,  @V_RATP_IDSTATPAG,    @V_RATP_VRRATAJBOLPAG;
         END;
         CLOSE C_RATP;
         DEALLOCATE C_RATP;
      END;

      FETCH NEXT FROM C_AJBOLP INTO @V_AJBOLP_CDFILIAL,    @V_AJBOLP_NRLANBOLPAG, @V_AJBOLP_CDAJUCTPAG,
                                    @V_AJBOLP_CDCLASSFINA, @V_AJBOLP_CDEMMFAJBOLP, @V_AJBOLP_CDFIMFAJBOLP,
                                    @V_AJBOLP_DTMOVFLUXO,  @V_AJBOLP_IDMOVFLUXO,   @V_AJBOLP_VRAJBOLPAG,
                                    @V_AJBOLP_IDAJUCTPAG;

   END;
   CLOSE C_AJBOLP;
   DEALLOCATE C_AJBOLP;



   DECLARE C_AJBOLR CURSOR FOR
      SELECT
         AJ.CDFILIAL,    AJ.NRLANBOLREC,  AJ.CDAJUCTREC,
         AJ.CDCLASSFINA, AJ.CDEMMFAJBOLR, AJ.CDFIMFAJBOLR,
         AJ.DTMOVFLUXO,  AJ.IDMOVFLUXO,   AJ.VRAJBOLREC,
         TR.IDAJUCTREC
      FROM TIPOAJRECEBER TR, AJBOLREC AJ
      WHERE AJ.CDAJUCTREC = TR.CDAJUCTREC
      ORDER BY AJ.CDFILIAL, AJ.NRLANBOLREC, AJ.CDAJUCTREC;

   OPEN C_AJBOLR;

   FETCH NEXT FROM C_AJBOLR INTO @V_AJBOLR_CDFILIAL,    @V_AJBOLR_NRLANBOLREC,  @V_AJBOLR_CDAJUCTREC,
                                 @V_AJBOLR_CDCLASSFINA, @V_AJBOLR_CDEMMFAJBOLR, @V_AJBOLR_CDFIMFAJBOLR,
                                 @V_AJBOLR_DTMOVFLUXO,  @V_AJBOLR_IDMOVFLUXO,   @V_AJBOLR_VRAJBOLREC,
                                 @V_AJBOLR_IDAJUCTREC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT
         @V_ACHOUR = COUNT(*)
      FROM
         MOVFXAJBOLR MA
      WHERE
         (@V_AJBOLR_CDFILIAL    = MA.CDFILIBOLREC) AND
         (@V_AJBOLR_NRLANBOLREC = MA.NRLANBOLREC)  AND
         (@V_AJBOLR_CDAJUCTREC  = MA.CDAJUCTREC);

      IF @V_ACHOUR = 0 BEGIN
         IF @V_AJBOLR_CDCLASSFINA IS NOT NULL BEGIN
            IF @V_AJBOLR_IDAJUCTREC = 'A' BEGIN
               SET @V_VRAJBOLREC = @V_AJBOLR_VRAJBOLREC * -1;
            END
            ELSE BEGIN
               SET @V_VRAJBOLREC = @V_AJBOLR_VRAJBOLREC;
            END;

            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJBOLR_CDEMMFAJBOLR, @V_AJBOLR_CDFIMFAJBOLR,
                                         @V_AJBOLR_DTMOVFLUXO,   @V_AJBOLR_IDMOVFLUXO,
                                         @V_AJBOLR_CDCLASSFINA,  @V_VRAJBOLREC, 0;
         END;

         DECLARE C_RATR CURSOR FOR
            SELECT
               AJ.CDFILIAL, AJ.NRLANBOLREC, AJ.CDAJUCTREC,
               AJ.VRAJBOLREC,   CR.CDCLASSFINA, CR.CDEMPRESA,
               CR.CDFIMOVFLREC, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
               TA.IDAJUCTREC,   CR.IDSTATREC,
               (CASE MAX(BR.VRBOLREC) WHEN 0
                THEN 0
                ELSE (MAX(AJ.VRAJBOLREC) * SUM(CR.VRATUAREC))/ MAX(BR.VRBOLREC) END) VRRATAJBOLREC
            FROM
              CONTARECEBER  CR, BOLETRECEBER BR,
              TIPOAJRECEBER TA, AJBOLREC   AJ
            WHERE
              (AJ.CDFILIAL     = @V_AJBOLR_CDFILIAL)    AND
              (AJ.NRLANBOLREC  = @V_AJBOLR_NRLANBOLREC) AND
              (AJ.CDAJUCTREC   = @V_AJBOLR_CDAJUCTREC)  AND
              (TA.CDAJUCTREC   = AJ.CDAJUCTREC)  AND
              (BR.CDFILIAL     = AJ.CDFILIAL)    AND
              (BR.NRLANBOLREC  = AJ.NRLANBOLREC) AND
              (CR.CDFILIBOLREC = BR.CDFILIAL)    AND
              (CR.NRLANBOLREC  = BR.NRLANBOLREC)
            GROUP BY
              AJ.CDFILIAL,     AJ.NRLANBOLREC, AJ.CDAJUCTREC,
              AJ.VRAJBOLREC,   CR.CDCLASSFINA, CR.CDEMPRESA,
              CR.CDFIMOVFLREC, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
              TA.IDAJUCTREC,   CR.IDSTATREC;

         OPEN C_RATR;

         FETCH NEXT FROM C_RATR INTO   @V_RATR_CDFILIAL,     @V_RATR_NRLANBOLREC, @V_RATR_CDAJUCTREC,   @V_RATR_VRAJBOLREC,
                                       @V_RATR_CDCLASSFINA,  @V_RATR_CDEMPRESA,   @V_RATR_CDFIMOVFLREC, @V_RATR_DTMOVFLUXO,
                                       @V_RATR_IDMOVFLUXO,   @V_RATR_IDAJUCTREC,  @V_RATR_IDSTATREC,    @V_RATR_VRRATAJBOLREC;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF @V_AJBOLR_CDCLASSFINA IS NOT NULL BEGIN
               IF @V_RATR_IDAJUCTREC = 'A' BEGIN
                  SET @V_VRAJBOLREC = ROUND(@V_RATR_VRRATAJBOLREC, 2);
               END
               ELSE BEGIN
                  SET @V_VRAJBOLREC = ROUND(@V_RATR_VRRATAJBOLREC * -1, 2);
               END;

               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_RATR_CDEMPRESA,   @V_RATR_CDFIMOVFLREC,
                                            @V_RATR_DTMOVFLUXO,  @V_RATR_IDMOVFLUXO,
                                            @V_RATR_CDCLASSFINA, @V_VRAJBOLREC, 0;

               INSERT INTO MOVFXAJBOLR
                  (CDCLASSFINA, CDEMPRESA,  CDFILIAL,
                   DTMOVFLUXO,  IDMOVFLUXO, CDFILIBOLREC,
                   NRLANBOLREC, CDAJUCTREC, VRFXAJBOLREC)
               VALUES
                  (@V_RATR_CDCLASSFINA, @V_RATR_CDEMPRESA,  @V_RATR_CDFIMOVFLREC,
                   @V_RATR_DTMOVFLUXO,  @V_RATR_IDMOVFLUXO, @V_RATR_CDFILIAL,
                   @V_RATR_NRLANBOLREC, @V_RATR_CDAJUCTREC, @V_RATR_VRRATAJBOLREC);

            END;
            FETCH NEXT FROM C_RATR INTO   @V_RATR_CDFILIAL,     @V_RATR_NRLANBOLREC, @V_RATR_CDAJUCTREC,   @V_RATR_VRAJBOLREC,
                                          @V_RATR_CDCLASSFINA,  @V_RATR_CDEMPRESA,   @V_RATR_CDFIMOVFLREC, @V_RATR_DTMOVFLUXO,
                                          @V_RATR_IDMOVFLUXO,   @V_RATR_IDAJUCTREC,  @V_RATR_IDSTATREC,    @V_RATR_VRRATAJBOLREC;

         END;
         CLOSE C_RATR;
         DEALLOCATE C_RATR;
      END;

      FETCH NEXT FROM C_AJBOLR INTO @V_AJBOLR_CDFILIAL,    @V_AJBOLR_NRLANBOLREC,  @V_AJBOLR_CDAJUCTREC,
                                    @V_AJBOLR_CDCLASSFINA, @V_AJBOLR_CDEMMFAJBOLR, @V_AJBOLR_CDFIMFAJBOLR,
                                    @V_AJBOLR_DTMOVFLUXO,  @V_AJBOLR_IDMOVFLUXO,   @V_AJBOLR_VRAJBOLREC,
                                    @V_AJBOLR_IDAJUCTREC;

   END;
   CLOSE C_AJBOLR;
   DEALLOCATE C_AJBOLR;


   DECLARE C_AJCTP CURSOR FOR
      SELECT
         AJ.CDFILIAL,    AJ.NRLANCTONF,   AJ.NRSEQVENPAG,  AJ.NRPARCELAPAG, AJ.DTAJUSTEPAG,
         AJ.CDAJUCTPAG,  AJ.DSAJUSTEPAG,  AJ.VRAJUSTEPAG,  AJ.CDECTBAJPAG,  AJ.NRLCTBAJPAG,
         AJ.CDCLASSFINA, AJ.CDEMMFAJCNTP, AJ.CDFIMFAJCNTP, AJ.DTMOVFLUXO,   AJ.IDMOVFLUXO,
         TA.IDAJUCTPAG
      FROM TIPOAJPAGAR TA, AJCTPAGAR AJ
      WHERE TA.CDAJUCTPAG = AJ.CDAJUCTPAG;

   OPEN C_AJCTP;

   FETCH NEXT FROM C_AJCTP INTO
      @V_AJCTP_CDFILIAL,     @V_AJCTP_NRLANCTONF,  @V_AJCTP_NRSEQVENPAG, @V_AJCTP_NRPARCELAPAG,
      @V_AJCTP_DTAJUSTEPAG,  @V_AJCTP_CDAJUCTPAG,  @V_AJCTP_DSAJUSTEPAG, @V_AJCTP_VRAJUSTEPAG,
      @V_AJCTP_CDECTBAJPAG,  @V_AJCTP_NRLCTBAJPAG, @V_AJCTP_CDCLASSFINA, @V_AJCTP_CDEMMFAJCNTP,
      @V_AJCTP_CDFIMFAJCNTP, @V_AJCTP_DTMOVFLUXO,  @V_AJCTP_IDMOVFLUXO,  @V_AJCTP_IDAJUCTPAG;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT V_CDCLASSFINA = CDCLASSFINA
      FROM CONTAPAGAR
      WHERE
         CDFILIAL     = @V_AJCTP_CDFILIAL     AND
         NRLANCTONF   = @V_AJCTP_NRLANCTONF   AND
         NRSEQVENPAG  = @V_AJCTP_NRSEQVENPAG  AND
         NRPARCELAPAG = @V_AJCTP_NRPARCELAPAG;

      IF @V_AJCTP_CDCLASSFINA <> @V_CDCLASSFINA BEGIN
         IF @V_AJCTP_IDAJUCTPAG = 'A' BEGIN
            SET @V_VRAJANTE  = @V_AJCTP_VRAJUSTEPAG * -1;
            SET @V_VRAJNOVO  = @V_AJCTP_VRAJUSTEPAG;
         END
         ELSE BEGIN
            SET @V_VRAJANTE  = @V_AJCTP_VRAJUSTEPAG;
            SET @V_VRAJNOVO  = @V_AJCTP_VRAJUSTEPAG * -1;
         END;
         EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJCTP_CDEMMFAJCNTP, @V_AJCTP_CDFIMFAJCNTP,
                                      @V_AJCTP_DTMOVFLUXO,   @V_AJCTP_IDMOVFLUXO,
                                      @V_AJCTP_CDCLASSFINA,  0,  @V_VRAJANTE;

         EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJCTP_CDEMMFAJCNTP, @V_AJCTP_CDFIMFAJCNTP,
                                      @V_AJCTP_DTMOVFLUXO,   @V_AJCTP_IDMOVFLUXO,
                                      @V_CDCLASSFINA,  0,  @V_VRAJNOVO;

         UPDATE AJCTPAGAR
         SET CDCLASSFINA = @V_CDCLASSFINA
         WHERE
            CDFILIAL     = @V_AJCTP_CDFILIAL     AND
            NRLANCTONF   = @V_AJCTP_NRLANCTONF   AND
            NRSEQVENPAG  = @V_AJCTP_NRSEQVENPAG  AND
            NRPARCELAPAG = @V_AJCTP_NRPARCELAPAG AND
            DTAJUSTEPAG  = @V_AJCTP_DTAJUSTEPAG  AND
            CDAJUCTPAG   = @V_AJCTP_CDAJUCTPAG;
      END;

      FETCH NEXT FROM C_AJCTP INTO
         @V_AJCTP_CDFILIAL,     @V_AJCTP_NRLANCTONF,  @V_AJCTP_NRSEQVENPAG, @V_AJCTP_NRPARCELAPAG,
         @V_AJCTP_DTAJUSTEPAG,  @V_AJCTP_CDAJUCTPAG,  @V_AJCTP_DSAJUSTEPAG, @V_AJCTP_VRAJUSTEPAG,
         @V_AJCTP_CDECTBAJPAG,  @V_AJCTP_NRLCTBAJPAG, @V_AJCTP_CDCLASSFINA, @V_AJCTP_CDEMMFAJCNTP,
         @V_AJCTP_CDFIMFAJCNTP, @V_AJCTP_DTMOVFLUXO,  @V_AJCTP_IDMOVFLUXO,  @V_AJCTP_IDAJUCTPAG;

   END;
   CLOSE C_AJCTP;
   DEALLOCATE C_AJCTP;


   DECLARE C_AJCTR CURSOR FOR
      SELECT
         AJ.CDFILIAL,    AJ.NRLANCTONF,   AJ.DTAJUSTEREC,  AJ.CDAJUCTREC,  AJ.DSAJUSTEREC,
         AJ.VRAJUSTEREC, AJ.CDECTBAJREC,  AJ.NRLCTBAJREC,  AJ.NRSEQVENREC, AJ.NRPARCELAREC,
         AJ.CDCLASSFINA, AJ.CDEMMFAJCNTR, AJ.CDFIMFAJCNTR, AJ.DTMOVFLUXO,  AJ.IDMOVFLUXO,
         TA.IDAJUCTREC
      FROM TIPOAJRECEBER TA, AJCTRECEBER AJ
      WHERE TA.CDAJUCTREC = AJ.CDAJUCTREC;

   OPEN C_AJCTR;

   FETCH NEXT FROM C_AJCTR INTO
      @V_AJCTR_CDFILIAL,     @V_AJCTR_NRLANCTONF,   @V_AJCTR_DTAJUSTEREC, @V_AJCTR_CDAJUCTREC,
      @V_AJCTR_DSAJUSTEREC,  @V_AJCTR_VRAJUSTEREC,  @V_AJCTR_CDECTBAJREC, @V_AJCTR_NRLCTBAJREC,
      @V_AJCTR_NRSEQVENREC,  @V_AJCTR_NRPARCELAREC, @V_AJCTR_CDCLASSFINA, @V_AJCTR_CDEMMFAJCNTR,
      @V_AJCTR_CDFIMFAJCNTR, @V_AJCTR_DTMOVFLUXO,   @V_AJCTR_IDMOVFLUXO,  @V_AJCTR_IDAJUCTREC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT V_CDCLASSFINA = CDCLASSFINA
      FROM CONTARECEBER
      WHERE
         CDFILIAL     = @V_AJCTR_CDFILIAL     AND
         NRLANCTONF   = @V_AJCTR_NRLANCTONF   AND
         NRSEQVENREC  = @V_AJCTR_NRSEQVENREC  AND
         NRPARCELAREC = @V_AJCTR_NRPARCELAREC;

      IF @V_AJCTR_CDCLASSFINA <> @V_CDCLASSFINA BEGIN
         IF @V_AJCTR_IDAJUCTREC = 'A' BEGIN
            SET @V_VRAJANTE  = @V_AJCTR_VRAJUSTEREC * -1;
            SET @V_VRAJNOVO  = @V_AJCTR_VRAJUSTEREC;
         END
         ELSE BEGIN
            SET @V_VRAJANTE  = @V_AJCTR_VRAJUSTEREC;
            SET @V_VRAJNOVO  = @V_AJCTR_VRAJUSTEREC * -1;
         END;

         EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJCTR_CDEMMFAJCNTR, @V_AJCTR_CDFIMFAJCNTR,
                                      @V_AJCTR_DTMOVFLUXO,   @V_AJCTR_IDMOVFLUXO,
                                      @V_AJCTR_CDCLASSFINA,  @V_VRAJANTE, 0;

         EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJCTR_CDEMMFAJCNTR, @V_AJCTR_CDFIMFAJCNTR,
                                      @V_AJCTR_DTMOVFLUXO,   @V_AJCTR_IDMOVFLUXO,
                                      @V_CDCLASSFINA,  @V_VRAJNOVO, 0;

         UPDATE AJCTRECEBER
         SET CDCLASSFINA = @V_CDCLASSFINA
         WHERE
            CDFILIAL     = @V_AJCTR_CDFILIAL     AND
            NRLANCTONF   = @V_AJCTR_NRLANCTONF   AND
            NRSEQVENREC  = @V_AJCTR_NRSEQVENREC  AND
            NRPARCELAREC = @V_AJCTR_NRPARCELAREC AND
            DTAJUSTEREC  = @V_AJCTR_DTAJUSTEREC  AND
            CDAJUCTREC   = @V_AJCTR_CDAJUCTREC;
      END;

      FETCH NEXT FROM C_AJCTR INTO
         @V_AJCTR_CDFILIAL,     @V_AJCTR_NRLANCTONF,   @V_AJCTR_DTAJUSTEREC, @V_AJCTR_CDAJUCTREC,
         @V_AJCTR_DSAJUSTEREC,  @V_AJCTR_VRAJUSTEREC,  @V_AJCTR_CDECTBAJREC, @V_AJCTR_NRLCTBAJREC,
         @V_AJCTR_NRSEQVENREC,  @V_AJCTR_NRPARCELAREC, @V_AJCTR_CDCLASSFINA, @V_AJCTR_CDEMMFAJCNTR,
         @V_AJCTR_CDFIMFAJCNTR, @V_AJCTR_DTMOVFLUXO,   @V_AJCTR_IDMOVFLUXO,  @V_AJCTR_IDAJUCTREC;
   END;
   CLOSE C_AJCTR;
   DEALLOCATE C_AJCTR;
END;
GO

EXEC IMPORTA_FLUXO_AJUSTE;
GO

