import {
  Select,
  GridEditable,
  Button,
  Tabs,
  Form,
  DialogService,
  TreeGridEditable,
} from '@zeedhi/common';
import {
  Http,
  IDictionary,
  Metadata,
  IEventParam,
  Loader,
  Config,
  IDatasource,
} from '@zeedhi/core';
import { PmeMask } from '@/config';

export class ReceitaController {
  private appController = Loader.getInstance('AppController');

  private utilities = Loader.getInstance('Utilities');
  
  private utilitiesPLA = Loader.getInstance('UtilitiesPLA');

  private crudController = Loader.getInstance('CrudController');
  
  private paramsFields: IDictionary = {};

  public selectedPlate: IDictionary = {};

  public disabledFilter = true;

  public propChange = false;

  public disablePropChange = false;

  public eventRecipeChange!: Function;

  // para callDeleteRows
  
  private grid!: GridEditable;
  
  public gridEditController = Loader.getInstance('GridEditableController');

  private datasourceName = '';
  
  private checkedRows!: IDictionary;

  // campos de filtro

  public tpCard: IDictionary = {};

  public service: IDictionary = {};

  public branch: IDictionary = {};

  // visibilidade dos campos da receita
  public get idqtliqubrut() {
    // return this.paramsFields.IDQTLIQUBRUT === 'L';
    return true;
  }

  public get idqt() {
    return !this.idqtliqubrut;
    // return true;
  }

  public get idaprerece() {
    // return this.paramsFields.IDAPRERECE === 'S';
    return true;
  }

  public get idganhococc() {
    // return this.paramsFields.IDGANHOCOCC === 'S';
    return true;
  }

  public get idaprovcocc() {
    // return this.paramsFields.IDAPROVCOCC === 'S';
    return true;
  }

  public get idperdalimp() {
    // return this.paramsFields.IDPERDALIMP === 'S';
    return true;
  }

  public get idaprovlimp() {
    // return this.paramsFields.IDAPROVLIMP === 'S';
    return true;
  }

  public get idtempprep() {
    // return this.paramsFields.IDTEMPPREP === 'S';
    return true;
  }
  
  public get idutreqcompentd() {
    // return this.paramsFields.IDUTREQCOMPENTD === 'S';
    return true;
  }

  public get idutdiaslimseg() {
    // return this.paramsFields.IDUTDIASLIMSEG === 'S';
    return true;
  }
  
  public getVisibilityFields() {
    /*
    const row = { CDFILCENTPME: this.appController.getCdCentral() };
    Http.post('/visibilityFieldsReceita', { requestType: 'Row', row }).then((response) => {
      this.paramsFields = response.data.dataset.result;
    });
    */
  }

  // Funcoes receita
  public setFilterGrids() {
    if (document.getElementsByName('tabsRecipes').length > 0) {
      const tab = Metadata.getInstance<Tabs>('tabsRecipes');
      if (tab.activeTab === 0) this.setfilterRecipeStandard();
      else if (tab.activeTab === 1) this.setfilterRecipeTpCard();
      else if (tab.activeTab === 2) this.setFilterRecipeLocal();
      else this.setFilterRecipeService();
    }
  }
  
  public setfilterRecipeStandard() {
    const grid: GridEditable = Metadata.getInstance('RECIPE_STANDARD');
    const conditions = [
      {
        name: 'CDPRATO',
        operator: '=',
        value: this.selectedPlate.CDPRATO,
      },
      {
        name: 'CDFILAUXPRAT',
        operator: '=',
        value: this.selectedPlate.CDFILAUXPRAT ? this.selectedPlate.CDFILAUXPRAT : 'P',
      },
    ];
    grid.datasource.filter = conditions;
    grid.datasource.get().then(() => {
      // this.loadStandardRecipeData(conditions);
      const addButton: Button = grid.getChildInstance('addButton');
      addButton.disabled = false;
      // this.enabledTabs();
    });
  }

  public setfilterRecipeTpCard() {
    if (document.getElementsByName('RECIPE_TIPOCARD').length > 0) {
      const grid: GridEditable = Metadata.getInstance('RECIPE_TIPOCARD');
  
      const conditions = [
        {
          name: 'P_CDPRATO',
          operator: '=',
          value: this.selectedPlate.CDPRATO,
        },
        {
          name: 'P_CDFILAUXPRAT',
          operator: '=',
          value: this.selectedPlate.CDFILAUXPRAT ? this.selectedPlate.CDFILAUXPRAT : 'P',
        },
        {
          name: 'P_CDFILCENTPME',
          operator: '=',
          value: this.appController.getCdCentral(),
        },
        {
          name: 'P_CDTIPOCARD',
          operator: '=',
          value: this.tpCard.CDTIPOCARD || null,
        },
      ];
  
      grid.datasource.filter = conditions;
      grid.datasource.get().then(() => {
        const addButton: Button = grid.getChildInstance('addButton');
        addButton.disabled = false;
      });
    }
  }

  public setFilterRecipeLocal() {
    if (document.getElementsByName('RECIPE_LOCAL').length > 0) {
      const grid: GridEditable = Metadata.getInstance('RECIPE_LOCAL');
  
      const conditions = [
        {
          name: 'CDPRATO',
          operator: '=',
          value: this.selectedPlate.CDPRATO,
        },
        {
          name: 'CDFILIAL',
          operator: '=',
          value: this.branch.CDFILIAL || null,
        },
        {
          name: 'CDFILAUXPRAT',
          operator: '=',
          value: this.selectedPlate.CDFILAUXPRAT || 'P',
        },
      ];
      grid.datasource.filter = conditions;
      grid.datasource.get().then(() => {
        const addButton: Button = grid.getChildInstance('addButton');
        addButton.disabled = false;
      });
    }
  }

  public setFilterRecipeService() {
    if (document.getElementsByName('RECIPE_SERVICE').length > 0) {
      const grid: GridEditable = Metadata.getInstance('RECIPE_SERVICE');
      const conditions = [
        {
          name: 'CDPRATO',
          operator: '=',
          value: this.selectedPlate.CDPRATO,
        },
        {
          name: 'CDFILIAL',
          operator: '=',
          value: this.branch.CDFILIAL || null,
        },
        {
          name: 'CDSERVFILI',
          operator: '=',
          value: this.service.CDSERVFILI || null,
        },
        {
          name: 'CDFILAUXPRAT',
          operator: '=',
          value: this.selectedPlate.CDFILAUXPRAT || 'P',
        },
      ];
      grid.datasource.filter = conditions;
      grid.datasource.get().then(() => {
        const addButton: Button = grid.getChildInstance('addButton');
        addButton.disabled = false;
      });
    }
  }

  // Outras funcoes
  
  public setTabPlate() {
    const tab = Metadata.getInstance<Tabs>('tabsRecipes');
    if (this.selectedPlate.IDRECEITA === 'T') tab.activeTab = 1;
    else if (this.selectedPlate.IDRECEITA === 'F') tab.activeTab = 2;
    else if (this.selectedPlate.IDRECEITA === 'S') tab.activeTab = 3;
    else tab.activeTab = 0;
  }

  public addRow({ component }: IDictionary) {
    const grid: GridEditable = this.utilities.returnGrid(component) as GridEditable;
    this.propChange = false;
    this.disablePropChange = true;
    if (!this.gridEditController.newRow) {
      const item: IDictionary = {};
      if (grid.name === 'RECIPE_STANDARD') {
        item.IDQTDEFIXPR = 'N';
        item.IDTPREQPRODPADR = 'P';
        item.IDUTCOMPENTDIRP = 'N';
        item.IDPRODBASEPR = 'N';
        item.VRPEFATCOCPR = 0;
        item.VRPEFATCOCPRAP = 100;
        item.VRPEFATCORPR = 0;
        item.VRPEFATCORPRAP = 100;
        item.VRPEFATNUTPR = 100;
        item.HRTEMPPREPPR = null;
      } else if (grid.name === 'RECIPE_TIPOCARD') {
        item.IDQTDEFIXPRTP = 'N';
        // item.IDTPREQPRODPADR = 'P';
        item.IDUTCOMPENTDIRP = 'N';
        item.IDPRODBASEPRTP = 'N';
        item.VRPEFATCOCPRTP = 0;
        item.VRPEFATCOCPRTPAP = 100;
        item.VRPEFATCORPRTP = 0;
        item.VRPEFATCORPRTPAP = 100;
        item.VRPEFATNUTPRTP = 100;
        item.HRTEMPPREPPRTP = null;
      } else if (grid.name === 'RECIPE_LOCAL') {
        item.IDQTDEFIXLO = 'N';
        item.IDTPREQPRODFILI = 'P';
        item.IDUTCOMPENTDIRF = 'N';
        item.IDPRODBASELO = 'N';
        item.VRPEFATCOCLO = 0;
        item.VRPEFATCOCLOAP = 100;
        item.VRPEFATCORLO = 100;
        item.VRPEFATCORLOAP = 100;
        item.VRPEFATNUTLO = 100;
        item.HRTEMPPREPLO = null;
      } else if (grid.name === 'RECIPE_SERVICE') {
        item.IDQTDEFIXSE = 'N';
        item.IDTPREQPRODSERV = 'P';
        item.IDUTCOMPENTDIRS = 'N';
        item.IDPRODBASESE = 'N';
        item.VRPEFATCOCSE = 0;
        item.VRPEFATCOCSEAP = 100;
        item.VRPEFATCORSE = 0;
        item.VRPEFATCORSEAP = 100;
        item.VRPEFATNUTSE = 100;
        item.HRTEMPPREPSE = null;
      } else if (grid.name === 'RECIPE_REGION') {
        item.IDPRODBASEREGIAO = 'N';
        item.IDQTDEFIXREGIAO = 'N';
        item.IDPRODBASEREGIAO = 'P';
        item.VRPEFATCOCREGIAO = 0;
        item.VRPEFATCOCLOAP = 100;
        item.VRPEFATCORREGIAO = 0;
        item.VRPEFATCORLOAP = 100;
      } else {
        item.IDQTDEFIXPADQ = 'N';
        item.IDPRODBASEPADQ = 'P';
        item.IDPRODBASEPADQ = 'N';
        item.VRPEFATCOCPADQ = 0;
        item.VRPEFATCOCLOAP = 100;
        item.VRPEFATCORPADQ = 0;
        item.VRPEFATCORLOAP = 100;
      }
      
      item.__is_new = true;
      this.gridEditController.newRow = true;
      // grid.editing = true;
      grid.addNewRow(item, 'end');
      // grid.datasource.data.unshift(item);
      if (!this.gridEditController.isInlineEditing) this.gridEditController.onInlineEdit({ component: grid });
    }
  }

  public deleteRecipeStandard({ component }: IDictionary) {
    const grid = this.utilities.returnGrid(component) as GridEditable;
    const checkedRows = grid.selectedRows;

    if (checkedRows.length === 0) this.utilities.showAlert('alertWarning', 'pme::nenhumRegSelecionado', 'warning');
    else if (grid.datasource.data.length === checkedRows.length) {
      this.utilities.showAlert('alertError', 'pme::receitaPadraoUmItem', 'error');
    } else this.gridEditController.deleteCheckedRows({ component });
  }
  
  // Salvamento dos grids
  public saveRecipeStandard({ component }: IDictionary) {
    const grid: GridEditable = this.utilities.returnGrid(component) as GridEditable;
    const form = Metadata.getInstance<Form>('formRecipeStandard');
    
    if (form.validate()) {
      const rows: IDictionary = grid.datasource.data.filter((e: IDictionary) => e.EDITED);
      let ctrlEstoq = true;
      let active = true;
      let validHour = true;

      rows.forEach((e: IDictionary) => {
        e.CDPRATO = this.selectedPlate.CDPRATO;
        e.CDFILAUXPRAT = this.selectedPlate.CDFILAUXPRAT;
        // e.SGUNIDADE = e.SGUNIDPROD;
        e.QTLIMSEGPADR = e.QTLIMSEGPADR || null;
        e.QTCOMPLPRODPADR = e.QTCOMPLPRODPADR || 0;
        e.CDAPRERECE = e.CDAPRERECE || null;
        if (e.__is_new) e.CDPRODUTO = e.CDPRODUTOAUX;
        if (e.__is_new && e.IDCNTRESTOQ !== 'S') ctrlEstoq = false;
        if (e.__is_new && e.IDPRODATIV !== 'A') active = false;
        if (e.HRTEMPPREPPR && !this.utilities.timeIsValid(e.HRTEMPPREPPR)) validHour = false;
        e.HRTEMPPREPPR = this.utilities.formatHour(e.HRTEMPPREPPR, false);
      });

      if (this.saveIsValid(validHour, ctrlEstoq, active)) this.callSave('/saveRecipeStandard', rows, grid);
    }
  }

  public saveRecipeTpCard({ component }: IDictionary) {
    const grid: GridEditable = this.utilities.returnGrid(component) as GridEditable;
    const form = Metadata.getInstance<Form>('formRecipeTpcard');
    
    if (form.validate()) {
      const rows: IDictionary = grid.datasource.data.filter((e: IDictionary) => e.EDITED);
      let ctrlEstoq = true;
      let active = true;
      let validHour = true;

      rows.forEach((e: IDictionary) => {
        e.CDTIPOCARD = this.tpCard.CDTIPOCARD;
        e.CDPRATO = this.selectedPlate.CDPRATO;
        e.CDFILAUXPRAT = this.selectedPlate.CDFILAUXPRAT;
        // e.SGUNIDADE = e.SGUNIDPROD;
        e.CDAPRERECE = e.CDAPRERECE || null;
        if (e.__is_new) e.CDPRODUTO = e.CDPRODUTOAUX;
        if (e.__is_new && e.IDCNTRESTOQ !== 'S') ctrlEstoq = false;
        if (e.__is_new && e.IDPRODATIV !== 'A') active = false;
        if (e.HRTEMPPREPPRTP && !this.utilities.timeIsValid(e.HRTEMPPREPPRTP)) validHour = false;
        e.HRTEMPPREPPRTP = this.utilities.formatHour(e.HRTEMPPREPPRTP, false);
        e.CDFILCENTPME = this.appController.getCdCentral();
      });

      if (this.saveIsValid(validHour, ctrlEstoq, active)) this.callSave('/saveRecipeTpCard', rows, grid);
    }
  }

  public saveRecipeLocal({ component }: IDictionary) {
    const grid: GridEditable = this.utilities.returnGrid(component) as GridEditable;
    const form = Metadata.getInstance<Form>('formRecipeLocal');
    
    if (form.validate()) {
      const rows: IDictionary = grid.datasource.data.filter((e: IDictionary) => e.EDITED);
      let ctrlEstoq = true;
      let active = true;
      let validHour = true;

      rows.forEach((e: IDictionary) => {
        e.CDFILIAL = this.branch.CDFILIAL;
        e.CDPRATO = this.selectedPlate.CDPRATO;
        e.CDFILAUXPRAT = this.selectedPlate.CDFILAUXPRAT;
        // e.SGUNIDADE = e.SGUNIDPROD;
        e.QTLIMSEGFILI = e.QTLIMSEGFILI || null;
        e.QTCOMPLPRODFILI = e.QTCOMPLPRODFILI || 0;
        e.CDAPRERECE = e.CDAPRERECE || null;
        if (e.__is_new) e.CDPRODUTO = e.CDPRODUTOAUX;
        if (e.__is_new && e.IDCNTRESTOQ !== 'S') ctrlEstoq = false;
        if (e.__is_new && e.IDPRODATIV !== 'A') active = false;
        if (e.HRTEMPPREPLO && !this.utilities.timeIsValid(e.HRTEMPPREPLO)) validHour = false;
        e.HRTEMPPREPLO = this.utilities.formatHour(e.HRTEMPPREPLO, false);
      });
      
      if (this.saveIsValid(validHour, ctrlEstoq, active)) this.callSave('/saveRecipeLocal', rows, grid);
    }
  }

  public saveRecipeService({ component }: IDictionary) {
    const grid: GridEditable = this.utilities.returnGrid(component) as GridEditable;
    const form = Metadata.getInstance<Form>('formRecipeService');
    
    if (form.validate()) {
      const rows: IDictionary = grid.datasource.data.filter((e: IDictionary) => e.EDITED);
      let ctrlEstoq = true;
      let active = true;
      let validHour = true;

      rows.forEach((e: IDictionary) => {
        e.CDFILIAL = this.branch.CDFILIAL;
        e.CDSERVFILI = this.service.CDSERVFILI;
        e.CDPRATO = this.selectedPlate.CDPRATO;
        e.CDFILAUXPRAT = this.selectedPlate.CDFILAUXPRAT;
        // e.SGUNIDADE = e.SGUNIDADE;
        e.QTLIMSEGSERV = e.QTLIMSEGSERV || null;
        e.QTCOMPLPRODSERV = e.QTCOMPLPRODSERV || 0;
        e.CDAPRERECE = e.CDAPRERECE || null;
        if (e.__is_new) e.CDPRODUTO = e.CDPRODUTOAUX;
        if (e.__is_new && e.IDCNTRESTOQ !== 'S') ctrlEstoq = false;
        if (e.__is_new && e.IDPRODATIV !== 'A') active = false;
        if (e.HRTEMPPREPSE && !this.utilities.timeIsValid(e.HRTEMPPREPSE)) validHour = false;
        e.HRTEMPPREPSE = this.utilities.formatHour(e.HRTEMPPREPSE, false);
      });
      
      if (this.saveIsValid(validHour, ctrlEstoq, active)) this.callSave('/saveRecipeService', rows, grid);
    }
  }

  private saveIsValid(validHour: boolean, ctrlEstoq: boolean, active: boolean) {
    let result = true;
    if (!validHour) this.utilities.showAlert('alertHour', 'pme::horaInvalida', 'warning');
    else if (!ctrlEstoq) this.utilities.showAlert('alertEstoq', 'pme::prodNaoControlaEstoq', 'warning');
    else if (!active) this.utilities.showAlert('alertActive', 'pme::prodInativoUnidade', 'warning');

    if (!validHour || !ctrlEstoq || !active) result = false;
    return result;
  }

  private callSave(url: string, rows: IDictionary, grid: GridEditable) {
    Http.post(url, { requestType: 'Row', row: rows }).then((response) => {
      if (response) {
        // this.editable = false;
        this.callEventRecipeChange();
        this.utilities.showAlert('alertSuccess', 'pme::salvoComSucesso', 'green');
        this.gridEditController.defaultState(grid);
      }
    }).catch((error: string) => {
      if (error.indexOf('ORA-00001') >= 0) this.utilities.showAlert('alert', 'pme::impossivelAdicionar', 'error');
      else this.utilities.showAlert('alert', `pme::${error}`, 'error');
    }).finally(() => {
      this.disablePropChange = false;
    });
  }

  // Filtro dos fields
  public setFilterBranch({ component }: IEventParam<Select>) {
    const conditions = [
      {
        name: 'CDOPERADOR',
        operator: '=',
        value: 'OPERADOR_LOGADO',
      },
      {
        name: 'CDGRUPFILI',
        operator: '=',
        value: 'T',
      },
    ];
    
    component.datasource.filter = conditions;
    component.datasource.get();
  }

  public setFilterService({ component }: IEventParam<Select>) {
    const branch: Select = Metadata.getInstance('BRANCH_SERVICE');
    const conditions = [
      {
        name: 'CDFILIAL',
        operator: '=',
        value: branch.value?.CDFILIAL || this.branch.CDFILIAL,
      },
      {
        name: 'IDTIPOSERV',
        operator: '=',
        value: this.utilitiesPLA.isMerenda() ? '' : 'N',
      },
    ];
    component.datasource.filter = conditions;
    component.datasource.get();
  }

  // Outras funcoes
  
  public saveRecRegion() {
    const form = Metadata.getInstance<Form>('formRecipeRegion');
    const grid: GridEditable = Metadata.getInstance('RECIPE_REGION');
    const editedRows = grid.getEditedRows() as IDictionary;
    
    const plateTree = Metadata.getInstance<TreeGridEditable>('plateTreeGrid');
    const currentRow = plateTree.datasource.currentRow;
    const formRegiao = Metadata.getInstance<Form>('FORM_REGIAO');
    
    const rows: IDictionary = grid.datasource.data.filter((e: IDictionary) => e.EDITED);

    rows.forEach((e: IDictionary) => {
      e.NRRECEREGIAO = '';
      e.NRPADRAOQUALIDADE = formRegiao.value.NMPADRAOQUALIDADE.NRPADRAOQUALIDADE;
      e.CDPADRAOQUALIDADE = formRegiao.value.NMPADRAOQUALIDADE.CDPADRAOQUALIDADE;
      e.CDREGIAO = formRegiao.value.NMREGIAO.CDREGIAO;
      e.CDPRATO = currentRow.CDPRATO;
      e.CDPRODUTO = e.CDPRODUTOAUX;
      e.CDFILAUXPRAT = currentRow.CDFILAUXPRAT;
      e.QTBRUTAREGIAOUNR = editedRows[0].QTBRUTAREGIAOUNR;
      e.QTPRODRECREGIAO = editedRows[0].QTBRUTAREGIAOUNR;
      e.SGUNIDADE = e.SGUNIDPROD;
      e.CDFILCENTPME = this.appController.getCdCentral();
    });
    
    if (form.validate() && editedRows.length > 0) {
      this.callSave('/saveRecipeRegion', rows.at(-1), grid);
    }
  }
  
  public saveRecPadq() {
    const form = Metadata.getInstance<Form>('formRecipePadraoQualidade');
    const grid: GridEditable = Metadata.getInstance('RECIPE_PADRAOQUALIDADE');
    const editedRows = grid.getEditedRows() as IDictionary;
    
    const plateTree = Metadata.getInstance<TreeGridEditable>('plateTreeGrid');
    const currentRow = plateTree.datasource.currentRow;
    const formRegiao = Metadata.getInstance<Form>('FORM_PADRAOQUALIDADE');
    
    const rows: IDictionary = grid.datasource.data.filter((e: IDictionary) => e.EDITED);

    rows.forEach((e: IDictionary) => {
      e.NRRECEPADQUALI = '';
      e.NRPADRAOQUALIDADE = formRegiao.value.NMPADRAOQUALIDADE.NRPADRAOQUALIDADE;
      e.CDPADRAOQUALIDADE = formRegiao.value.NMPADRAOQUALIDADE.CDPADRAOQUALIDADE;
      e.CDPRATO = currentRow.CDPRATO;
      e.CDPRODUTO = e.CDPRODUTOAUX;
      e.CDFILAUXPRAT = currentRow.CDFILAUXPRAT;
      e.QTBRUTAPADQUNR = editedRows[0].QTBRUTAPADQUNR;
      e.QTPRODRECREGIAO = editedRows[0].QTBRUTAPADQUNR;
      e.SGUNIDADE = e.SGUNIDPROD;
      e.CDFILCENTPME = this.appController.getCdCentral();
    });
    
    if (form.validate() && editedRows.length > 0) {
      this.callSave('/saveRecipePadraoQualidade', rows.at(-1), grid);
    }
  }
  
  public configCalculateCustom({ row, component }: IDictionary) {
    const gridParent = component.parent;
    let typeFieldVR = '';
    let typeFieldQT = '';
    let required = '';
    if (gridParent.name === 'RECIPE_REGION') {
      typeFieldVR = 'REGIAO';
      typeFieldQT = 'RECREGIAO';
      required = 'REGIAOUNR';
    } else if (gridParent.name === 'RECIPE_PADRAOQUALIDADE') {
      typeFieldVR = 'PADQ';
      typeFieldQT = 'RECPADQ';
      required = 'PADQUNR';
    }

    const percentualChange = this.calculateFieldsCustom(row, component, typeFieldVR, typeFieldQT, required);
    
    if (this.propChange) {
      gridParent.datasource.data.forEach((e: IDictionary) => {
        if (row.CDPRODUTO !== e.CDPRODUTO && e[`IDQTDEFIX${typeFieldVR}`] !== 'S') {
          this.changeProportionalCustom(e, typeFieldVR, typeFieldQT, percentualChange);
        }
      });
    }
  }

  private calculateFieldsCustom(
    row: IDictionary, component: IDictionary, typeFieldVR: string,
    typeFieldQT: string, required: string,
  ) {
    row.EDITED = true;
    const nameField = component.name.split('_')[0];
    if (!row.OLDROW) row.OLDROW = { ...row };
    row[nameField] = component.value;

    if (nameField !== `VRPEFATCOC${typeFieldVR}`) row[`VRPEFATCOC${typeFieldVR}`] = row.VRPEFATCOCLOAP - 100; // ganho coccao
    if (nameField !== 'VRPEFATCOCLOAP') row.VRPEFATCOCLOAP = 100 + row[`VRPEFATCOC${typeFieldVR}`]; // aprov. coccao
    
    if (nameField !== `VRPEFATCOR${typeFieldVR}`) {
      // perda limpeza
      row[`VRPEFATCOR${typeFieldVR}`] = 100 - row.VRPEFATCORLOAP;
    }
    
    if (nameField !== 'VRPEFATCORLOAP') row.VRPEFATCORLOAP = 100 - row[`VRPEFATCOR${typeFieldVR}`]; // ap. limpeza

    let qtProd = row[`QTPROD${typeFieldQT}`];
    const qtBruta = row[`QTBRUTA${required}`];
    
    if (this.idqtliqubrut && nameField !== `QTPROD${typeFieldQT}`) { // quantidade
      row[`QTPROD${typeFieldQT}`] = qtBruta - ((qtBruta * row[`VRPEFATCOR${typeFieldVR}`]) / 100)
        + ((qtBruta * row[`VRPEFATCOC${typeFieldVR}`]) / 100);
      
      qtProd = row[`QTPROD${typeFieldQT}`];
    }

    row[`QTBRUTA${required}`] = qtProd - ((qtProd * row[`VRPEFATCOR${typeFieldVR}`]) / 100)
      + ((qtProd * row[`VRPEFATCOC${typeFieldVR}`]) / 100);
    
    // row[`QTPROD${typeFieldQT}`] = qtBruta - ((qtBruta * row[`VRPEFATCOR${typeFieldVR}`]) / 100) +
    // ((qtBruta * row[`VRPEFATCOC${typeFieldVR}`]) / 100);
    
    // return row[`QTBRUTA${required}`];
    return row[`QTBRUTA${required}`] / row.OLDROW[`QTBRUTA${required}`];
  }
  
  private changeProportionalCustom(row: IDictionary, typeFieldVR: string, typeFieldQT: string, percentual: number) {
    if (!row.OLDROW) row.OLDROW = { ...row };
    const oldRow = row.OLDROW;
    row.EDITED = true;
    
    row[`QTPROD${typeFieldQT}`] = oldRow[`QTPROD${typeFieldQT}`] * percentual;
    row[`QTBRUTA${typeFieldVR}UNR`] = oldRow[`QTBRUTA${typeFieldVR}UNR`] * percentual;
  }
  
  public configCalculate({ row, component }: IDictionary) {
    const gridParent = component.parent;
    let typeFieldVR = '';
    let typeFieldQT = '';
    let required = '';
    if (gridParent.name === 'RECIPE_STANDARD') {
      typeFieldVR = 'PR';
      typeFieldQT = 'PRAT';
      required = 'PRUNR';
    } else if (gridParent.name === 'RECIPE_TIPOCARD') {
      typeFieldVR = 'PRTP';
      typeFieldQT = 'PRATTP';
      required = 'PRUNRTP';
    } else if (gridParent.name === 'RECIPE_LOCAL') {
      typeFieldVR = 'LO';
      typeFieldQT = 'RECLOC';
      required = 'LOUNR';
    } else if (gridParent.name === 'RECIPE_SERVICE') {
      typeFieldVR = 'SE';
      typeFieldQT = 'RECSER';
      required = 'SEUNR';
    }

    const percentualChange = this.calculateFields(row, component, typeFieldVR, typeFieldQT, required);

    if (this.propChange) {
      gridParent.datasource.data.forEach((e: IDictionary) => {
        if (row.CDPRODUTO !== e.CDPRODUTO && e[`IDQTDEFIX${typeFieldVR}`] !== 'S') {
          this.changeProportional(e, typeFieldVR, typeFieldQT, percentualChange);
        }
      });
    }
    
    // row.NMPRODUTO = gridParent.NMPRODUTO.value;
    // row.NMPRODUTO = row.NMPRODUTOAUX;
    // gridParent.updateRow(row);
  }
  
  private calculateFields(
    row: IDictionary, component: IDictionary, typeFieldVR: string,
    typeFieldQT: string, required: string,
  ) {
    // if (!row.ORIGINAL) row.ORIGINAL = { ...row };
    row.EDITED = true;
    const nameField = component.name.split('_')[0];
    if (!row.OLDROW) row.OLDROW = { ...row };
    row[nameField] = component.value;

    if (nameField !== `VRPEFATCOC${typeFieldVR}`) {
      // ganho coccao
      row[`VRPEFATCOC${typeFieldVR}`] = row[`VRPEFATCOC${typeFieldVR}AP`] - 100;
    }
    
    if (nameField !== `VRPEFATCOC${typeFieldVR}AP`) {
      // aprov. coccao
      row[`VRPEFATCOC${typeFieldVR}AP`] = 100 + row[`VRPEFATCOC${typeFieldVR}`];
    }
    
    if (nameField !== `VRPEFATCOR${typeFieldVR}`) {
      // perda limpeza
      row[`VRPEFATCOR${typeFieldVR}`] = 100 - row[`VRPEFATCOR${typeFieldVR}AP`];
    }
    
    if (nameField !== `VRPEFATCOR${typeFieldVR}AP`) {
      // aprov. limpeza
      row[`VRPEFATCOR${typeFieldVR}AP`] = 100 - row[`VRPEFATCOR${typeFieldVR}`];
    }

    const qtProd = row[`QTPROD${typeFieldQT}`];
    const qtBruta = row[`QTBRUTA${typeFieldVR}`];

    if (!this.idqtliqubrut && nameField !== `QTBRUTA${typeFieldVR}`) { // qtd bruta
      row[`QTBRUTA${typeFieldVR}`] = qtProd - ((qtProd * row[`VRPEFATCOR${typeFieldVR}`]) / 100)
        + ((qtProd * row[`VRPEFATCOC${typeFieldVR}`]) / 100);
    }
    if (this.idqtliqubrut && nameField !== `QTPROD${typeFieldQT}`) { // quantidade
      row[`QTPROD${typeFieldQT}`] = qtBruta - ((qtBruta * row[`VRPEFATCOR${typeFieldVR}`]) / 100)
        + ((qtBruta * row[`VRPEFATCOC${typeFieldVR}`]) / 100);
    }
    row[`QTBRUTA${typeFieldVR}UNR`] = row[`QTBRUTA${typeFieldVR}`];

    if (typeFieldVR === 'PRTP') row.QTBRUTAPRUNRTP = row[`QTBRUTA${typeFieldVR}`];

    row[`QTCALCNUTR${typeFieldVR}`] = ((row[`VRPEFATNUT${typeFieldVR}`] * row[`QTPROD${typeFieldQT}`]) / 100);

    row[`QTBRUTA${required}`] = row.VRFATOCONVES
      ? row[`QTBRUTA${typeFieldVR}`] * row.VRFATOCONVES
      : row[`QTBRUTA${typeFieldVR}`];
    
    row[`QTUNIDEST${typeFieldVR}`] = row[`QTBRUTA${required}`];

    return row[`QTBRUTA${typeFieldVR}`] / row.OLDROW[`QTBRUTA${typeFieldVR}`];
  }

  private changeProportional(row: IDictionary, typeFieldVR: string, typeFieldQT: string, percentual: number) {
    if (!row.OLDROW) row.OLDROW = { ...row };
    const oldRow = row.OLDROW;
    row.EDITED = true;
    
    row[`QTBRUTA${typeFieldVR}`] = oldRow[`QTBRUTA${typeFieldVR}`] * percentual;
    row[`QTPROD${typeFieldQT}`] = oldRow[`QTPROD${typeFieldQT}`] * percentual;
    row[`QTBRUTA${typeFieldVR}UNR`] = oldRow[`QTBRUTA${typeFieldVR}UNR`] * percentual;

    if (typeFieldVR === 'PRTP') row.QTBRUTAPRUNRTP = oldRow.QTBRUTAPRUNRTP * percentual;

    row[`QTCALCNUTR${typeFieldVR}`] = oldRow[`QTCALCNUTR${typeFieldVR}`] * percentual;

    row[`QTUNIDEST${typeFieldVR}`] = oldRow[`QTUNIDEST${typeFieldVR}`] * percentual;
  }

  public setRowEdited({ row, component }: IDictionary) {
    row.EDITED = true;
    const nameField = component.name.split('_')[0];
    row[nameField] = component.value;
  }
  
  public setRowCdApre({ row, component }: IDictionary) {
    row.EDITED = true;
    row.CDAPRERECE = component.value;
  }
  
  public setRowSgunidEdited({ row, component }: IDictionary) {
    this.setRowEdited({ row, component });
    const gridParent = component.parent;
    if (component.selectValue) {
      const vrfatoconves = component.selectValue.VRFATOCONVES ? component.selectValue.VRFATOCONVES : 1;
      row.VRFATOCONVES = vrfatoconves;
      
      let typeField = '';
      let bruta;
      
      if (gridParent.name === 'RECIPE_STANDARD') {
        bruta = 'PR';
        typeField = 'PRUNR';
      } else if (gridParent.name === 'RECIPE_TIPOCARD') {
        bruta = 'PRTP';
        typeField = 'PRUNRTP';
      } else if (gridParent.name === 'RECIPE_LOCAL') {
        bruta = 'LO';
        typeField = 'LOUNR';
      } else if (gridParent.name === 'RECIPE_SERVICE') {
        bruta = 'SE';
        typeField = 'SEUNR';
      } else if (gridParent.name === 'RECIPE_PADRAOQUALIDADE') {
        bruta = 'PADQ';
        typeField = 'PADQUNR';
      } else if (gridParent.name === 'RECIPE_REGION') {
        bruta = 'REGIAO';
        typeField = 'REGIAOUNR';
      }
      
      if (row[`QTBRUTA${bruta}`]) {
        row[`QTBRUTA${typeField}`] = (vrfatoconves) ? row[`QTBRUTA${bruta}`] * vrfatoconves : row[`QTBRUTA${bruta}`];
        row[`QTUNIDEST${bruta}`] = row[`QTBRUTA${typeField}`];
      }
    }
  }

  public fieldDefaultValue({ component }: IEventParam<Select>) {
    if (component.disabled) {
      if (component.name === 'TIPOCARD') {
        component.datasource.data = [this.tpCard];
        component.setValue(this.tpCard);
      } else if (component.name === 'BRANCH_LOCAL' || component.name === 'BRANCH_SERVICE') {
        component.datasource.data = [this.branch];
        component.setValue(this.branch);
      } else if (component.name === 'SERVICE') {
        component.datasource.data = [this.service];
        component.setValue(this.service);
      }
    }
  }

  public getFilterProd() {
    return [
      {
        name: 'CDFILIAL',
        operator: '=',
        value: this.branch.CDFILIAL,
      },
    ];
  }

  public filterSGUN({ row, component }: IDictionary) {
    const filter = [
      {
        name: 'CDPRODUTO',
        operator: '=',
        value: row.CDPRODUTO || row.CDPRODUTOAUX || null,
      },
      {
        name: 'SGUNIDADE',
        operator: '=',
        value: row.SGUNIDPROD || null,
      },
      {
        name: 'SGUNIDESTO',
        operator: '=',
        value: null,
      },
      {
        name: 'TSGUNIDADE',
        operator: '=',
        value: 'T',
      },
    ];
    component.datasource.filter = filter;
    component.datasource.get();
  }

  public filterApre({ row, component }: IDictionary) {
    const filter = [
      {
        name: 'P_CDPRODUTO',
        operator: '=',
        value: row.CDPRODUTO || row.CDPRODUTOAUX || null,
      },
    ];
    component.datasource.filter = filter;
    component.datasource.get();
  }

  public produtoComponentProps = {
    component: 'ZdSelect',
    dataText: [
      {
        name: 'CDARVPROD',
        mask: (Config.masks.productMask as PmeMask).pattern,
      },
      'NMPRODUTO',
    ],
    formatterDataText: [
      {
        name: 'CDARVPROD',
        mask: (Config.masks.productMask as PmeMask).pattern,
      },
      'NMPRODUTO',
    ],
    dataValue: 'CDPRODUTO',
    dataValueOut: [
      {
        column: 'CDARVPROD',
        columnOnGrid: 'CDARVPROD',
      },
      {
        column: 'SGUNIDADE',
        columnOnGrid: 'SGUNIDADE',
      },
      {
        column: 'SGUNIDADE',
        columnOnGrid: 'SGUNIDPROD',
      },
    ],
    cssClass: 'columnProdGridWidth',
    returnObject: true,
    datasource: {
      uniqueKey: 'CDARVPROD',
      route: '/find/pratoProdutoEstoque',
      type: 'rest',
      limit: 10,
      lazyLoad: true,
    },
    validations: {
      required: {
        message: 'pme::campoObrigatorio',
      },
    },
    events: {
      change: '{{ReceitaController.setLimpParams}}',
    },
  };

  public setLimpParams({ component, row }: IDictionary) {
    const gridParent = component.parent;
    const value = component.value;
    let type = '';
    
    if (gridParent.name === 'RECIPE_STANDARD') type = 'PR';
    else if (gridParent.name === 'RECIPE_TIPOCARD') type = 'PRTP';
    else if (gridParent.name === 'RECIPE_LOCAL') type = 'LO';
    else if (gridParent.name === 'RECIPE_SERVICE') type = 'SE';
    else if (gridParent.name === 'RECIPE_REGION') type = 'REGIAO';
    else if (gridParent.name === 'RECIPE_PADRAOQUALIDADE') type = 'PADQ';
    
    if (value) {
      row.CDPRODUTOAUX = value.CDPRODUTO;
      row.IDCNTRESTOQ = value.IDCNTRESTOQ;
      row.IDPRODATIV = value.IDPRODATIV;
      row.SGUNIDADE = value.SGUNIDADE;
      row.SGUNIDPROD = value.SGUNIDADE;
      // row.NMPRODUTOAUX = value.NMPRODUTO;
      row[`VRPEFATCOR${type}`] = value.VRPEFATOCORR;
      row[`VRPEFATCOR${type}AP`] = value.APROVLIMPEZA;
    }
  }

  public cancelEditing({ component }: IDictionary) {
    this.disablePropChange = false;
    this.gridEditController.cancelEditing({ component });
  }

  public async deleteCheckedRows({ component }: IDictionary) {
    this.grid = this.utilities.returnGrid(component) as GridEditable;
    this.checkedRows = this.grid.selectedRows;
    if (this.checkedRows.length === 0) this.utilities.showAlert('alert', 'pme::nenhumRegSelecionado', 'warning');
    else {
      const regexFind = /\/find/gm;
      this.datasourceName = (this.grid.datasource as IDatasource).route.replace(regexFind, '');
      DialogService.show({
        name: component.name,
        type: 'warning',
        title: 'pme::atencao',
        text: 'pme::desejaExcluirRegistros',
        buttons: [
          {
            name: 'yes',
            component: 'ZdButton',
            label: 'pme::sim',
            events: { click: () => this.callDeleteRows() },
            outline: true,
          },
          {
            name: 'no',
            component: 'ZdButton',
            label: 'pme::nao',
            events: { click: () => DialogService.hide() },
          },
        ],
      });
    }
  }

  private callDeleteRows() {
    this.crudController.deleteRows(this.checkedRows, this.datasourceName).then(() => {
      this.grid.cancelEditedRows();
      this.grid.datasource.get();
      this.grid.selectedRows = [];
      DialogService.hide();
      this.utilities.showAlert('alert', 'pme::excluidoComSucesso', 'success');
      this.callEventRecipeChange();
    }).catch((error: string) => {
      DialogService.hide();
      this.utilities.showAlert('alert', `pme::${error}`, 'error');
    });
  }

  public callEventRecipeChange() {
    if (this.eventRecipeChange !== undefined && typeof this.eventRecipeChange === 'function') this.eventRecipeChange();
  }
}
